/**
  ******************************************************************************
  * File Name          : freertos.c
  * Description        : Code for freertos applications
  ******************************************************************************
  * This notice applies to any and all portions of this file
  * that are not between comment pairs USER CODE BEGIN and
  * USER CODE END. Other portions of this file, whether 
  * inserted by the user or by software development tools
  * are owned by their respective copyright owners.
  *
  * Copyright (c) 2018 STMicroelectronics International N.V. 
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without 
  * modification, are permitted, provided that the following conditions are met:
  *
  * 1. Redistribution of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  * 3. Neither the name of STMicroelectronics nor the names of other 
  *    contributors to this software may be used to endorse or promote products 
  *    derived from this software without specific written permission.
  * 4. This software, including modifications and/or derivative works of this 
  *    software, must execute solely and exclusively on microcontroller or
  *    microprocessor devices manufactured by or for STMicroelectronics.
  * 5. Redistribution and use of this software other than as permitted under 
  *    this license is void and will automatically terminate your rights under 
  *    this license. 
  *
  * THIS SOFTWARE IS PROVIDED BY STMICROELECTRONICS AND CONTRIBUTORS "AS IS" 
  * AND ANY EXPRESS, IMPLIED OR STATUTORY WARRANTIES, INCLUDING, BUT NOT 
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
  * PARTICULAR PURPOSE AND NON-INFRINGEMENT OF THIRD PARTY INTELLECTUAL PROPERTY
  * RIGHTS ARE DISCLAIMED TO THE FULLEST EXTENT PERMITTED BY LAW. IN NO EVENT 
  * SHALL STMICROELECTRONICS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
  * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "FreeRTOS.h"
#include "task.h"
#include "cmsis_os.h"

/* USER CODE BEGIN Includes */     
#include "DIALOG.h"
/* USER CODE END Includes */

/* Variables -----------------------------------------------------------------*/
osThreadId defaultTaskHandle;

/* USER CODE BEGIN Variables */
osThreadId GUI_TaskHandle;
osThreadId GUI_UpdateTaskHandle;

WM_HWIN hDlg;
TEXT_Handle hTxt0;
static unsigned int uwCnt;
char data[10];
/* USER CODE END Variables */

/* Function prototypes -------------------------------------------------------*/
void StartDefaultTask(void const * argument);


extern void MX_LIBJPEG_Init(void);
extern void MX_USB_DEVICE_Init(void);
extern void MX_FATFS_Init(void);
void MX_FREERTOS_Init(void); /* (MISRA C 2004 rule 8.1) */

/* USER CODE BEGIN FunctionPrototypes */
void GUI_Task(void const * argument);
void GUI_UpdateTask(void const * argument);
extern WM_HWIN CreateWindow(void);
extern void GUI_UpdateControlText(WM_HWIN _hDialogControl);


/* USER CODE END FunctionPrototypes */

/* Hook prototypes */

/* Init FreeRTOS */

void MX_FREERTOS_Init(void) {
  /* USER CODE BEGIN Init */
       
  /* USER CODE END Init */

  /* USER CODE BEGIN RTOS_MUTEX */
  /* add mutexes, ... */
  /* USER CODE END RTOS_MUTEX */

  /* USER CODE BEGIN RTOS_SEMAPHORES */
  /* add semaphores, ... */
  /* USER CODE END RTOS_SEMAPHORES */

  /* USER CODE BEGIN RTOS_TIMERS */
  /* start timers, add new ones, ... */
  /* USER CODE END RTOS_TIMERS */

  /* Create the thread(s) */
  /* definition and creation of defaultTask */
  osThreadDef(defaultTask, StartDefaultTask, osPriorityNormal, 0, 128);
  defaultTaskHandle = osThreadCreate(osThread(defaultTask), NULL);


  /* USER CODE BEGIN RTOS_THREADS */
  /* add threads, ... */
	osThreadDef(GUI_Update, GUI_UpdateTask, osPriorityHigh, 1, 2000);
  GUI_UpdateTaskHandle = osThreadCreate(osThread(GUI_Update), NULL);
	
//	osThreadDef(GUI_Thread, GUI_Task, osPriorityNormal, 1, 2048);
//  GUI_TaskHandle = osThreadCreate(osThread(GUI_Thread), NULL);
  /* USER CODE END RTOS_THREADS */

  /* USER CODE BEGIN RTOS_QUEUES */
  /* add queues, ... */
  /* USER CODE END RTOS_QUEUES */
}

/* StartDefaultTask function */
void StartDefaultTask(void const * argument)
{
  /* init code for LIBJPEG */
//  MX_LIBJPEG_Init();

//  /* init code for USB_DEVICE */
//  MX_USB_DEVICE_Init();

//  /* init code for FATFS */
//  MX_FATFS_Init();

  /* USER CODE BEGIN StartDefaultTask */
	/* Infinite loop */
  for(;;)
  {
    osDelay(200);
  }
  /* USER CODE END StartDefaultTask */
}

/* USER CODE BEGIN Application */
//void GUI_Task(void const * argument)
//{
//	
//	hDlg = CreateWindow();
//	
//	for(;;)
//  { 
//		GUI_UpdateControlText(hDlg);
//    osDelay(200);
//  }
//}	
/*******************************************************************
* 
*		GUI background processing
* 
*		This task does the background processing.
* 	The main job is to update invalid windows, but other things such as
* 	evaluating mouse or touch input may also be done.
*******************************************************************/
void GUI_UpdateTask(void const * argument)
{

	/* Activate the use of memory device feature */
  WM_SetCreateFlags(WM_CF_MEMDEV);	
	
	hDlg = CreateWindow();
	
	hTxt0 = WM_GetDialogItem(hDlg, (GUI_ID_USER + 0x08));		

	
	TEXT_SetFont(hTxt0,GUI_FONT_24_1);
	while (1) 
	{
		
		sprintf(data,"%d",uwCnt);
		TEXT_SetText(hTxt0,data);
		uwCnt++;
		osDelay(100);			

		
    GUI_Exec();           /* Do the background work ... Update windows etc.) */
		GUI_X_ExecIdle();     /* Nothing left to do for the moment ... Idle processing */
		osDelay(500);
  }
}
/* USER CODE END Application */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
